'Zamek na kart telefoniczn CHIP Wersja 1- testowa
'Autor: Bartosz W. "Kocisko"
'WWW.BASCOMANIA.PL
'Projekt suy do zabawy i dalszego rozpowszechniania ;)
'Wicej informacji o projekcie na stronie Bascomanii
'Program zosta napisany w oparciu o informacje wyszukane z internetu
'Nie odczytuje numeru ID karty, ale itak pobiera z niej nie powtarzalny cig znakw
'Moe w nastpnej wersji uda si pobiera konkretny numer karty,
'Jeli wiesz jak i umiesz udoskonali ten projekt, to zrb to i podziel si nim na
'WWW.BASCOMANIA.PL
'Enjoy
'------------------------------------------------------------

$PROG &HFF , &HA4 , &HD9 , &H00                             ' generated. Take care that the chip supports all fuse bytes.

$regfile = "m8def.DAT"                                      'deklaracja procesora, w tym wypadku Atmega8
$crystal = 8000000                                          'deklaracja taktowania

$baud = 9600                                                'ustawienie prdkoci transmisji danych dla UART

Dim X As Byte
Dim Z As Byte
Dim T As Byte
Dim R As Byte
Dim A As Byte
Dim Y As Word
Dim Id As Integer
Dim Ciag As String * 12                                     'cig znakw odczytany z karty
Dim K As Integer
Dim Odczyt(5) As Eram String * 12                           'zadeklarowanie miejsc w pamici w ktrych zapisywane s numery kart
                                                               'aktualnie moliwe zapisanie do 5 kart. Opcj t mona zmieni, ale trzeba te zmienic
                                                               'dalej wartoci w ptlach for

Dim Rsodczyt As String * 12

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3 , E = Portc.4 , Rs = Portc.5

Config Pinb.0 = Input                                       'klawisz usuwania
Config Pinb.2 = Input                                       'klawisz czyszczenia pamieci
Config Pinb.1 = Input                                       'klawisz zapisu
Config Portb.4 = Output                                     '1 reset karty
Config Portb.5 = Output                                     '2 sygna zegarowy karty
Config Pinb.6 = Input                                       '3 wejscie danych z karty
Config Pinb.7 = Input                                       '4 kontrola woenia karty
Config Portd.3 = Output                                     'dioda zielona
Config Portd.5 = Output                                     'dioda czerwona
Config Portd.7 = Output                                     'pin otwierajcy zamek


Res Alias Portb.4
Clk Alias Portb.5
Io Alias Pinb.6
Stan Alias Pinb.7

Zapisz Alias Pinb.1                                         'klawisz zapisu
Wyrzuc Alias Pinb.0                                         'klawisz usuwania
Czysc Alias Pinb.2                                          'klawisz czyszczenia pamieci eeprom

Zielona Alias Portd.3
Czerwona Alias Portd.5
Zamek Alias Portd.7

                        '--- ustawienie stanw pocztkowych ---

Ciag = " "


Res = 0
Clk = 0

portd = 255
portb = 255

cls

           '---wprowadziem komunikaty przez UART, w celu kontroli tego co si dzieje
           '---Jeli chcesz z tego skorzysta uwaaj przy wykonaniu plytki i kondensatorach!!!
Print "Czytnik aktywny"                                     'wywietl tekst przez UART
home
cursor off noblink
lcd "Czytnik aktywny"
Wait 2                                                      ' czytnik rozpoczyna prac
cls

Do
If Stan = 0 Then
   Print "wloz karte"                                       ' jesli karta nie wlozona podaj komunikat
   home
   lcd "   Wloz karte   "
   locate 2 , 1
   lcd "                "
  else
   home
   lcd "  Czytam karte  "
   locate 2 , 1
   lcd "                "
End If
                                                         'start programu
Zielona = 1                                                 'zgaszenie did i zamknicie zamka
Czerwona = 1
Zamek = 1

Ciag = ""
Czysc = 1

Waitms 20

If Czysc = 0 Then                                           'jesli wcisniety klawisz czyszczenia...
   gosub czyszczenie
End If

If Stan <> 0 Then                                           'czekaj dopki karta nie bedzie woona
   Waitms 50
   Id = 0

                                              'wywoaj reset chipa
   Gosub Reset_chip

   For R = 1 To 6                                           ' odczytanie 6 razy po 7 bitw z karty
      For X = 0 To 7
         '
         Gosub Adres

         A.x = Io

      Next X

      Ciag = Ciag + Hex(a)                                  'zapis odczytanych bitw w postaci szesnastkowego ciagu
   Next R

   Ciag = Mid(ciag , 2 , 11)                                'usunicie pierwszego znaku cigu, bo zawsze jest 0


Print "ID karty: " ; Ciag                                   'wyswietl numer karty

Waitms 100
Gosub Koniec                                                'po odczycie przejdz do podprogramu koncowego

End If
Waitms 50

Loop                                                        'ptla
End                                                         'koniec programu

Reset_chip:                                                 'procedura resetu chipa

   Res = 1
   Delay
   Clk = 1
   Delay
   Clk = 0
   Delay
   Res = 0
   Delay

Return
                                                           'procedura odczytu bitw
Adres:
   Res = 0
   Delay
   Clk = 1
   Delay
   Clk = 0
   Delay

Return

Koniec:                                                     'podprogram kocowy

Do

Test:

Zapisz = 1
Wyrzuc = 1
Zielona = 1
Czerwona = 1
Zamek = 1
                                                          ' zapis karty
If Zapisz = 0 Then
   For K = 1 To 5
      Rsodczyt = Odczyt(k)
      Print "sprawdzam zawartosc <" ; Rsodczyt ; ">"
      If Rsodczyt = Ciag Then
         Cls
         Lcd "juz jest"
         Goto Test
         Waitms 50


      End If
   Next K

   For K = 1 To 5
      Rsodczyt = Odczyt(k)
      Print "sprawdzam zawartosc <" ; Rsodczyt ; ">"
      If Rsodczyt = "xxx" Then
         Odczyt(k) = Ciag


         Cls
         Lcd "zapisane"

         Zielona = 0
         Waitms 500
         Zielona = 1
         Waitms 500
         Zielona = 0
         Waitms 500
         Zielona = 1

         Goto Test
         Waitms 50
      End If
Next K
   'Return
End If


If Wyrzuc = 0 Then                                          'usuniecie karty


   For K = 1 To 5
      Rsodczyt = Odczyt(k)
      Print "sprawdzam zawartosc <" ; Rsodczyt ; ">"
      If Rsodczyt = Ciag Then
         Odczyt(k) = "xxx"

         Cls
         Lcd "usuniete"
         Print "usunalem"
         Czerwona = 0
         Waitms 500
         Czerwona = 1
         Waitms 500
         Czerwona = 0
         Waitms 500
         Czerwona = 1

         Waitms 50
         Goto Test
      End If
   Next K
   'Return
End If


For K = 1 To 5


   Rsodczyt = Odczyt(k)
   Print "rs  " ; K ; "  " ; Rsodczyt
   If Rsodczyt = Ciag Then
      Gosub Otworz

    End If
Next K

Stan = 1

Waitms 100

Return

Loop
End


Otworz:                                                     'procedura otwarcia
Do
Wyrzuc = 1


If Stan <> 0 Then
      home
      lcd "    Otwarte     "
      wait 1

      Print "otwarte"
      Zielona = 0
      Zamek = 0
      Locate 2 , 1
      Lcd "Id=" ; Ciag
      Waitms 50
      If Wyrzuc = 0 Then Gosub Koniec

   Else
      home
      lcd "   Zamkniete    "
      wait 1
      Return
End If

Loop
End

czyszczenie:
   home
   lcd "Czyszcze pamiec"
   wait 1

   For K = 1 To 5
   Odczyt(k) = "xxx"                                        'to zapisz we wszystkich zadeklarowanych komrkach wartosc "xxx"

   Print "czyszcze  " ; K                                   'wyswietl komunikat
   Next K                                                   'sygna wietlny
   Czerwona = 0                                             'mruganie czerwonej diody
   Waitms 500
   Czerwona = 1
   Zielona = 0
   Waitms 500
   Zielona = 1

   cls
return